	PSR_IRQ_MODE            =   0x12
	PSR_SYS_MODE            =   0x1f
	WRAM_END                =   0x03008000

	.TEXT

	.CODE 32

	.EXTERN     AgbMain

#
#	start
#

	.include "rom_header.s"

	.GLOBAL     _start
_start:
        mov     r0, #PSR_IRQ_MODE
        msr     cpsr, r0
        ldr     sp, sp_irq
        mov     r0, #PSR_SYS_MODE
        msr     cpsr, r0
        ldr     sp, sp_usr

	ldr	r0, =__bss_start
	ldr	r1, =__bss_end
	mov	r2, #0
clrbss:
	stmia	r0!, {r2}
	cmp	r0, r1
	blo	clrbss

	@	load variables and code into .iwram and .iwram0 sections
	ldr     r0, =__iwram_start
	ldr     r1, =__load_start_iwram
	ldr     r2, =__load_stop_iwram0
cpyiwr:
	ldmia	r1!,{r3}
	stmia	r0!,{r3}
	cmp	r1, r2
	blo	cpyiwr

        ldr     r1, =AgbMain
        mov     lr, pc
        bx      r1
        b       _start

    .ALIGN
sp_usr: .word   WRAM_END - 0x100
sp_irq: .word   WRAM_END - 0x60

    .END

