/*
 *	jpegutil.c
 */

#include <gba.h>
#include <stdarg.h>

#include <gbafs.h>

#include "jpeglib.h"
// #include "dma.h"

void safefree(void *p)
{
	// TODO: Not implemented yet.
}

void PrintFreeMem(void)
{
	// printf("Used memory=%d, Remain=%d\n", MaxUse, GetFreeHeap());
}

static int	consX, consY;

void _consoleInit()
{
	consX = consY = 0;
}

void _consolePrintf(char const *fmt, ...)
{
#if 0
	va_list	vp;
	u8	buf[80];

	va_start(vp, fmt);
	_vsprintf(buf, (u8*)fmt, vp);
	Fix8PutStr(consX, consY, (u8*)buf);
	consY += 10;
	if (consY >= (SCREEN_HEIGHT - 10))
		consY = 0;
	va_end(vp);
#endif
}

typedef struct _FILEINFO {
	PDIRENT	pdir;
	char	*pfile;
	u32	curoff;
} FILEINFO, *PFILEINFO;

static FILEINFO	fileinfo[2];

void FileSys_SetFileInfo(void *FileInfo, s32 FileIndex)
{
	PFILEINFO	pfi = &fileinfo[FileIndex];
	PDIRENT		pdir = (PDIRENT)FileInfo;

	pfi->pdir = pdir;
	pfi->pfile = (char*)(pdir->fileaddr + pdir->namesize);
	pfi->curoff = 0;
}

int FileSys_fopen(u32 FileIndex)
{
	return True;
}

u32 FileSys_fread (void* buffer, u32 size, u32 count, int file)
{
	PFILEINFO	pfi = &fileinfo[file];

	memcpy(buffer, &pfi->pfile[pfi->curoff], size * count);
	pfi->curoff += size * count;
}

void *FileSys_GetFilePtr(u32 size, u32 count, int file)
{
	PFILEINFO	pfi = &fileinfo[file];
	void		*pfile;

	pfile = (void*)&pfi->pfile[pfi->curoff];
	pfi->curoff += size * count;

	return pfile;
}

int FileSys_fseek(int file, u32 offset, int origin)
{
	PFILEINFO	pfi = &fileinfo[file];

	pfi->curoff = offset;
}

void MemSet8DMA3(u8 v,void *dst,u32 len)
{
	memset(dst, v, len);
}

#if 0

void MemCopy16DMA3(void *src,void *dst,u32 len)
{
	while ((READ_REG16(REG_DM3CNT_H) & BIT15)!=0);

	WRITE_REG32(REG_DM3SAD, (u32)src);
	WRITE_REG32(REG_DM3DAD, (u32)dst);
	WRITE_REG16(REG_DM3CNT_L, len / 2);
	WRITE_REG16(REG_DM3CNT_H, 
		DMA_SIZE_16 | DMA_TRANSFER_ON | DMA_TIMING_NOW | 
		DMA_REPEAT_OFF | DMA_SAD_INC | DMA_DAD_INC | DMA_INTR_ON);
}

void MemMove16DMA3(void *src,void *dst,u32 len)
{
	while ((READ_REG16(REG_DM3CNT_H) & BIT15)!=0);

	WRITE_REG32(REG_DM3SAD, (u32)src + len - 2);
	WRITE_REG32(REG_DM3DAD, (u32)dst + len - 2);
	WRITE_REG16(REG_DM3CNT_L, len / 2);
	WRITE_REG16(REG_DM3CNT_H, 
		DMA_SIZE_16 | DMA_TRANSFER_ON | DMA_TIMING_NOW | 
		DMA_REPEAT_OFF | DMA_SAD_DEC | DMA_DAD_DEC | DMA_INTR_ON);
}

void MemCopy32DMA3(void *src,void *dst,u32 len)
{
	while ((READ_REG16(REG_DM3CNT_H) & BIT15)!=0);

	WRITE_REG32(REG_DM3SAD, (u32)src);
	WRITE_REG32(REG_DM3DAD, (u32)dst);
	WRITE_REG16(REG_DM3CNT_L, len / 4);
	WRITE_REG16(REG_DM3CNT_H, 
		DMA_SIZE_32 | DMA_TRANSFER_ON | DMA_TIMING_NOW | 
		DMA_REPEAT_OFF | DMA_SAD_INC | DMA_DAD_INC | DMA_INTR_ON);
}

void MemMove32DMA3(void *src,void *dst,u32 len)
{
	while ((READ_REG16(REG_DM3CNT_H) & BIT15)!=0);

	WRITE_REG32(REG_DM3SAD, (u32)src + len - 4);
	WRITE_REG32(REG_DM3DAD, (u32)dst + len - 4);
	WRITE_REG16(REG_DM3CNT_L, len / 4);
	WRITE_REG16(REG_DM3CNT_H, 
		DMA_SIZE_32 | DMA_TRANSFER_ON | DMA_TIMING_NOW | 
		DMA_REPEAT_OFF | DMA_SAD_DEC | DMA_DAD_DEC | DMA_INTR_ON);
}

#endif // 0

void MWin_ProgressHide(void)
{
}

void MWin_ProgressSetPos(s32 _Position)
{
}

void MWin_ProgressShow(char *TitleStr,s32 _Max)
{
}

void ShowLogHalt(void)
{
}

